<?php

/**
 * @file Handles external auth providers
 */


/**
 * Create a Discourse account and log in the user to the new account.
 *
 * @param array $params
 *
 * @todo Manage the situation where admin approval is required.
 */
function discourse_auth_create_user($params) {
  if (isset($_SESSION['discourse']) && $_POST['email'] == $_SESSION['discourse']['auth']['email']) {
    unset($_SESSION['discourse']);
    include_once(drupal_get_path('module', 'discourse') . '/includes/discourse_user.inc');
    $user_id = discourse_create_user($params);
    $discourse_user = discourse_get_discourse_user_by_params(array('id' => $user_id));
    if ($discourse_user) {
      discourse_login($discourse_user);
      drupal_json_output(array(
        'success' => TRUE,
        'active' => TRUE,
        'message' => t('Your account is active and ready'),
      ));
    }
  }
  exit;
}



/**
 * External auth complete.
 *
 * @see /discourse/app/views/users/omniauth_callbacks/complete.html.erb
 */
function discourse_auth_complete($data) {
  $data_json = json_encode($data);
  print <<< EOF
    <html>
    <head></head>
    <body>
      <script type="text/javascript">
        window.opener.Discourse.authenticationComplete({$data_json});
        window.close();
      </script>
    </body>
    </html>
EOF;
  drupal_exit();
}
